// This file has been modified by KylinSoft Co., Ltd.
// Modifications copyright (C) 2024-2026 KylinSoft Co., Ltd.
//
// Licensed to the LF AI & Data foundation under one
// or more contributor license agreements. See the NOTICE file
// distributed with this work for additional information
// regarding copyright ownership. The ASF licenses this file
// to you under the Apache License, Version 2.0 (the
// "License"); you may not use this file except in compliance
// with the License. You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

#pragma once

#include <iostream>
#include <random>

#include "Database.h"

class Example {
public:
    // 里面调用了 connect
    Example();

    bool HasCollection();

    void CreateCollection();

    void DropCollection();

    void Insert();
    // 根据向量查询
    void Search();
    // 根据条件查询，比如主键
    int64_t Query();
    // 根据主键更新
    void Upsert(int64_t id);

    void Delete();

    ~Example();

private:
    std::shared_ptr<VectorDB::Database> client;
    std::string collection_name = "TEST";
    int dimension = 4;
};
